<?php

class AutoLoader {

public function __construct() {
    spl_autoload_register( array($this, 'load') );
    // spl_autoload_register(array($this, 'loadComplete'));
}

// This method will be automatically executed by PHP whenever it encounters an unknown class name in the source code
private function load($className) {
    $classFile = "";
    // TODO : compute path of the file to load (cf. PHP function is_readable)
    // it is in one of these subdirectory '/classes/', '/model/', '/controller/'
    // if it is a model, load its sql queries file too in sql/ directory
    if(strpos($className, "Controller") !==FALSE){
        $classFile .= __ROOT_DIR .  "/controller/";

    }else if(strpos($className, "Model") !==FALSE){
        $classFile .= __ROOT_DIR .  "/model/";

    }else if(strpos($className, "Role") !==FALSE){
        $classFile .= __ROOT_DIR . "../model/";

    }else if(strpos($className, "User") !==FALSE){
        $classFile .= __ROOT_DIR .  "/model/";

    }else if(strpos($className, "Response") !==FALSE){
        $classFile .= __ROOT_DIR . "/classes/";

    }else if(strpos($className, "Request") !==FALSE){
        $classFile .= __ROOT_DIR .  "/classes/";
        
    }else if(strpos($className, "Dispatcher") !==FALSE){
        $classFile .= __ROOT_DIR .  "/classes/";
        
    }else if(strpos($className, "DatabasePDO") !==FALSE){
        $classFile .= __ROOT_DIR .  "/classes/";
        
    }
    $classFile.=$className.".class.php";
    include $classFile;
}
}
$__LOADER = new AutoLoader();